﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2
{
    class Item13
    {

    }
    /*
    // For illustration, not complete source
    public class List<T> // : IEnumerable<T>
    {
        public struct Enumerator //: IEnumerator<T>
        {
            // Contains specific implementation of
            // MoveNext(), Reset(), and Current.

            public Enumerator(List<T> storage)
            {
                // elided
            }
        }

        public Enumerator GetEnumerator()
        {
            return new Enumerator(this);
        }

        // other List members.
    }*/

    public class PhoneNumber { }

    public class PhoneValidator
    {
        public bool ValidateNumber(PhoneNumber ph)
        {
            // perform validation.
            // Check for valid area code, exchange.
            return true;
        }
    }

    public interface IPhoneValidator
    {
        bool ValidateNumber(PhoneNumber ph);
    }

    internal class USPhoneValidator : IPhoneValidator
    {
        public bool ValidateNumber(PhoneNumber ph)
        {
            // perform validation.
            // Check for valid area code, exchange.
            return true;
        }
    }

    internal class InternationalPhoneValidator : IPhoneValidator
    {
        public bool ValidateNumber(PhoneNumber ph)
        {
            // perform validation.
            // Check international code.
            // Check specific phone number rules.
            return true;
        }
    }

    public static class PhoneValidation
    {
        public enum PhoneTypes
        {
            UnitedStates,
            UnitedKingdom,
            // .. others.
            Unknown
        }

        public static IPhoneValidator CreateValidator(PhoneTypes type)
        {
            switch (type)
            {
                case PhoneTypes.UnitedStates:
                    return new USPhoneValidator();
                case PhoneTypes.UnitedKingdom:
                    return new UKPhoneValidator();
                case PhoneTypes.Unknown:
                default:
                    return new InternationalPhoneValidator();
            }
        }
    }

    internal class UKPhoneValidator : IPhoneValidator
    {
        public bool ValidateNumber(PhoneNumber ph)
        {
            throw new NotImplementedException();
        }
    }
}
