﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2
{
    public struct MyStruct
    {
        private string msg;
        private int id;
        private DateTime epoch;

        internal void SetMessage(string v)
        {
            msg = v;
        }

        internal string GetMessage()
        {
            return msg;
        }
    }

    public class Customer
    {
        private decimal revenue;

        public Customer(string name) => 
            this.Name = name;

        public string Name { get; set; }

        public override int GetHashCode() =>
            Name.GetHashCode();
    }


    public class Item10
    {

        private class Order
        {

        }
        public static bool Tests()
        {

            var myHashMap = new Dictionary<Customer, object>();
            var orders = new object();

            Customer c1 = new Customer("Acme Products");
            myHashMap.Add(c1, orders);
            // Oops, the name is wrong:
            c1.Name = "Acme Software";

            MyStruct s = new MyStruct();
            s.SetMessage("Hello");
            return s.GetHashCode() == s.GetMessage().GetHashCode();

        }

        private static void test2()
        {
            var myDictionary = new Dictionary<Customer, Order>();
            var orders = new Order();


            Customer c1 = new Customer("Acme Products");
            myDictionary.Add(c1, orders);
            // Oops, the name is wrong:
           // Customer c2 = c1.ChangeName("Acme Software");
            Order o = myDictionary[c1];
            myDictionary.Remove(c1);
            //myDictionary.Add(c2, o);

        }
    }

    namespace VersionTwo
    {
        public struct MyStruct
        {
            private DateTime epoch;
            private string msg;
            private int id;
        }

        public class Customer
        {
            private decimal revenue;

            public Customer(string name) => this.Name = name;

            public string Name { get; }

            public decimal Revenue { get; set; }

            public override int GetHashCode() => 
                Name.GetHashCode();

            public Customer ChangeName(string newName) =>
                new Customer(newName) { Revenue = revenue };
        }


        public class Student
        {

        }
    }
}
